Uses LinuX;

{this could turn on the smoother line filter}
{$DEFINE BILINEA}
{$DEFINE OUTPUT_STDOUT}
{$DEFINE FRAME}


Const MAXX = 600; { X size of the image, in pixels}
      MaxY = 120; { Y size of the image, in pixels}
{$IFDEF FRAME}
      fr_MAXX = MAXX + 20;
      fr_MAXY = MAXY + 20;
{$ELSE}
      fr_MAXX = MAXX;
      fr_MAXY = MAXY;
{$ENDIF}      
      MAXE = 2000000; { maximum number of reports. Usually one report is
    		        generated by VGNETUPD per minute. 2 million updates
			are close to 4 years 24/7}
    {max speeds, in bits per second}
      MAX_TX_KBPS = 128000;
      MAX_RX_KBPS = 1000000;
      SOLID_Y = 20;
      
      SPACING_LRG = MAX_RX_KBPS  div 4;
      SPACING_SMALL = MAX_RX_KBPS div 20;
      
      InFile = '/home/vesko/develop/vgpanel/netst.log';
{      OutFile1 = '/home/vesko/develop/vgpanel/minutely.jpg';
      OutFile2 = '/home/vesko/develop/vgpanel/quartrly.jpg';}
      
{KOLORS Section: each color is an ARGB in a longint, with blue in the LSB}      

      NO_NET_C   =	$7f3266ff;
      NO_POWER_C = 	$7fffc08f;
      GRID	 =	$00505050;
      RX_C =		$6060da3b;
      TX_C =		$60da6352;
      HTML =		$00538fcc;
      
      NO_NET     = -1;
      NO_POWER   = -2;

Type  Report = Record
		time : Longint;
		Rx, TX : Longint;
		End;
		
{.BMP Phile Format:}		

const  BM_MAGIC  = 19778;

type	BM_HEADER = record
		    fs : Longint;
		    lzero : Longint;
		    bfImgOffset : Longint;
		    end;
	BM_iHEADER= record
		    ihdrSize : Longint;
		    x, y : Longint;
		    channels, bpp : Integer;
		    comp, biSizeImage : Longint;
		    PixPerM_X, PixPerM_Y : Longint;
		    colors, colorsimportant : Longint;
		    end;

      arr = array [0..MAXE-1] of Report;
      scarr = array [0..mAXX-1, 0..MAXY -1] of longint;
      sc_fr_arr = array [0..FR_MAXX-1, 0..FR_MAXY-1] of longint;

var opt : integer;
    n : Longint;
    a : arr;
    P : scarr;
{$IFDEF FRAME}    
    Q : sc_fr_arr;
{$ELSE}
    Q : scarr;    
{$ENDIF}
    interval, iv : longint;
{    outfile : String;}

Function FileExists(fn : string) : boolean;
 var g : Stat;
 begin
    fstat (fn, g);
    fileexists := (LINUXeRROR <> SYS_ENOENT);
 end;
 
Procedure Write_BMP;
 var G : BM_HEADER;
     H : BM_iHEADER;
     i, j, k : Integer;
     f : File Of Byte;
     row : Array [0..3 + Fr_MAXX * 3] of byte;
     rowsz : Longint;
 begin
{$IFNDEF FRAME}
 q := p;
{$ENDIF} 
 
 fillchar(g, sizeof(g), 0);
 fillchar(h, sizeof(h), 0);
{$IFDEF OUTPUT_STDOUT}
 assign(f, '');
{$ELSE}
 assign(f, 'test.bmp');
{$ENDIF}
 rewrite(f);
 
 rowsz := Fr_MAXX * 3;
 if rowsz mod 4 <> 0 then
    inc(rowsz, 4 - (rowsz mod 4));
 g.fs := 54 + rowsz * Fr_MAXY;
 g.bfImgOffset := 54;
 h.iHdrSize := 40;
 h.x := Fr_MAXX; h.y := Fr_MAXY;
 h.channels := 1;
 h.bpp := 24;
 k := BM_MAGIC;
 blockwrite(f, k, 2);
 blockwrite(f, g, sizeof(g));
 blockwrite(f, h, sizeof(h));
 fillchar(row, sizeof(row), 0);
 for j := Fr_MAXY - 1 downto 0 do
    begin
    for i := 0 to Fr_MAXX - 1 do	
	for k := 0 to 2 do 
	    begin
	    row [i*3+k] := 255 and q[i,j];
	    q[i,j] := q[i,j] shr 8;
	    end;
    blockwrite(f, row, rowsz);
    end;
 close(f);
 end; 

Function InX : boolean;
 var t : text;
 
 Function Safe_readLn(var a, b, c : Longint) : boolean;
  var s : string;
      i : integer;
      d : integer;
  begin
  safe_readln := false;
  readln(t, s);
  for i := 1 to length(s) do if not (s[i] in ['-',' ','0'..'9']) then exit;
  i := pos(' ', s);
  val(copy(s, 1, i-1), a, d);
  if d <> 0 then exit;
  delete(s, 1, i);
  i := pos(' ', s);
  val(copy(s, 1, i-1), b, d);
  if d <> 0 then exit;
  delete(s, 1, i);
  val(s, c, d);
  if d <> 0 then exit;
  safe_readln := true;
  end;
 
 begin
 InX := FALSE;
 if not fileexists(infile) then
    begin
    writeLn('The file does not exist: "',infile,'".');
    exit;
    end;
 assign(t, infile);
 reset(t);
 n := 0;
 while not seekeof(t) do
    begin
    if safe_readln( a[n].time, a[n].rx, a[n].tx) then inc(n);
    end;
 close(t);
 InX := TRUE;
 end;
 
Function clamp(a : longint) : longint;
 begin
 if a > 255 then a := 255;
 if a < 0 then a := 0;
 clamp := a;
 end; 
 
Procedure Decompose(col : longint; var alpha, r, g, b : longint);
 begin
 b := col and $ff; 	col := col shr 8;
 g := col and $ff;	col := col shr 8;
 r := col and $ff;	col := col shr 8;
 alpha := col;
 end;  
 
Procedure VDraw(x, y : integer; col : longint);
 begin
 if (x>=0) and (x<MAXX) and (y>=0) and (y<MAXY) then
    p[x,y] := col;
 end;  
 
Function MultiPlyColor(col : Longint; amp : real) : longint;
 var r,g, b, a : longint;
 begin
 Decompose(col, a, r, g, b);
 r := clamp(round(r*amp));
 g := clamp(round(g*amp));
 b := clamp(round(b*amp));
 MultiplyColor := r shl 16 + g shl 8 + b;
 end; 

Procedure Fdraw(x, y : integer; col : longint; transp : real);
 begin
 if (x>=0) and (x<MAXX) and (y>=0) and (y<MAXY) then
    p[x,y] := multiplycolor(p[x,y], (1-transp)) + multiplycolor(col, transp); 
 end; 

Procedure Frdraw(x, y : integer; col : longint; transp : real);
 begin
 if (x>=0) and (x<fr_MAXX) and (y>=0) and (y<fr_MAXY) then
    q[x,y] := multiplycolor(q[x,y], (1-transp)) + multiplycolor(col, transp); 
 end; 

Procedure Draw_solid(y : Integer); 
 var i : integer;
 begin
 for i := 0 to maxx - 1 do
    p[i,y] := GRID;
 end;
 
Procedure Draw_dotted(y : integer);
 var i : integer;
 begin
 for i := 0 to maxx - 1 do
    if (i mod 5 < 2) then 
	p[i,y] := GRID;
 end; 

Procedure Draw_Secondary_lines(xmax : Longint);
 var i, y : longint;
 begin
 xmax := round(xmax/iv);
 if xmax <=0 then xmax := 1;
 for i := 0 to 4 do 
    if i * SPACING_LRG <= xmax then
	begin
	y := maxy - 1 - round(( i * SPACING_LRG )/xmax * (maxy-1));
	draw_solid(y);
	end;
 for i := 0 to 20 do 
    if i * SPACING_SMALL <= xmax then
	begin
	y := maxy - 1 - round(( i * SPACING_SMALL )/xmax * (maxy-1));
	draw_dotted(y);
	end;
 end;

Procedure PrepareImage;
 var i, j : Integer;
     interleave : integer;
 begin
 if interval = 1 then interleave := 15; {fifteen minutes}
 if interval = 15 then interleave := 8; {two hours}
 fillchar(p, sizeof(p), 0);
 for j := 0 to Maxy-1 do
    for i := 0 to Maxx - 1 do 
	if i mod interleave = 0 then vdraw(i,j, GRID);
 end;
 
Procedure Draw_bar(x, start_y : Integer; col : Longint);
 var f : real;
     i : integer;
 begin
 f := (col shr 24) / 255.0;
 for i := start_y to MaxY - 1 do
    fdraw(x, i, col, f);
 end; 
 
Function GetF(x, max : Integer): real;
 begin
 if x< 20 then getf := (10-x)/10
	  else if x >= max-20 then getf := (10-(max-1-x))/10 else
	    getf := -10;
 end; 
 
Function Clipf(f : real) : real;
 begin
 if f < 0 then clipf := 0 else clipf := f;
 end; 
 
Function clip1(f : real) : real;
 begin
 if f > 1 then clip1 := 1.0
	  else clip1 := f;
 end; 
 
Function Kombine(f1, f2 : real) : real;
 var g : integer;
 begin
 g := integer(f1 > -5);
 g := g * 2 + integer(f2 > -5);
 case g of
    0: kombine := 0;
    1: kombine := clipf(f2);
    2: kombine := clipf(f1);
    3: kombine := clip1(0.80 * sqrt(sqr(clipf(f1+0.2)) + sqr(clipf(f2+0.2))));
    end;
 end; 
 
Procedure Draw_frame;
 var i, j : integer;
     f1, f2 : real;
 begin
 {kopy:}
 for i := 0 to MAXX - 1 do
    for j := 0 to maxy - 1 do
	q[i+10, j+10] := p[i,j];
 {enframe:}
 for i := 0 to FR_MAXX  - 1 do
    for j := 0 to FR_MAXY - 1 do
	begin
	f1 := GetF(i, FR_MAXX);
	f2 := GetF(j, FR_MAXY);
	frdraw(i,j, HTML, Kombine(f1, f2));
	end;
 end; 
 
Function GetState(time : LonGInT) : LOngint;
 var l, r, m, tgt, tgi : Longint;
 begin
 if (time < a[0].time - iv) or (time > a[n-1].time + iv) then 
    begin
    GetState := NO_POWER; {out of recorded universum}
    exit;
    end;
 if time < a[0].time then
    begin
    GetState := 0;
    if a[0].rx = -1 then GetState := NO_NET;
    exit;
    end;
 if time > a[n-1].time then
    begin
    GetState := n-1;
    if a[n-1].rx = -1 then GetState := NO_NET;
    exit;
    end;
 l := 0;
 r := n - 1;
 while (r-l > 1) do
    begin
    m := (l+r) div 2;
    if a[m].time > time then 
	r := m
	else
	l := m;
    end;
 if abs(time - a[l].time) < abs(time - a[r].time) then
    begin
    tgi := l;
    tgt := a[l].rx;
    end else
    begin
    tgi := r;
    tgt := a[r].rx;
    end;
 if abs(time - a[tgi].time ) > iv then
    begin
    GetState := NO_POWER;
    exit;
    end;
 if tgt = -1 then GetState := NO_NET
	     else GetState := TGI;
 end; 
 
Procedure SpeedClamp(var x : Longint; maxval : longint) ;
 begin
 if x > MaxVal then x := Maxval;
 if x <= 0 then x := 1;
 end;

Procedure DoWork;
 var ct, t, r, r1 : Longint;
     i, j : Integer;
     last : array [1..2] of integer;
     drx, dtx : longint;
     b : array [0..MAXX-1, 1..2] of Longint;
     xmax : longint;
     cc : longint;
     y, yi, k : integer;
     f, fi : real;
     
 begin
 PrepareImage;
 ct := GetEpochTime;
 iv := Interval * 60;
 for i := 0 to maxx - 1 do
    begin
    t := ct + iv * (i - maxx);
    r := getState(t);
    if r < 0 then
	begin
	case r of
	    NO_NET: draw_bar(i, MAXY - SOLID_Y, NO_NET_C);
	    NO_POWER : draw_bar(i, MAXY - SOLID_Y,  NO_POWER_C);
	    end;
	drx := -1;
	dtx := -1;
	end
	else
	begin
	r1 := getstate( t - iv );
	if r1 < 0 then 
	    begin
	    drx := 0;
	    dtx := 0;
	    end else
	    begin
	    drx := a[r].rx - a[r1].rx;
	    dtx := a[r].tx - a[r1].tx;
	    SpeedClamp(drx, iv * MAX_RX_KBPS); SpeedClamp(dtx, iv * MAX_TX_KBPS);
	    end;
	end;
    b[i,1] := drx;
    b[i,2] := dtx;	
    end;
 xmax := 0;
 for i := 0 to maxx - 1 do	
    for j := 1 to 2 do 
	if b[i,j] > xmax then xmax := b[i,j];
 if xmax = 0 then xmax := 1;
 draw_secondary_lines(xmax);
 for i := 0 to maxx - 1 do
    for j := 1 to 2 do
	if b[i,j] >= 0 then 
	    b[i,j] := round(b[i,j]/xmax*(maxy-1));
 last[1] := 0; last[2] := 0;
 for i := 0 to maxx - 1 do if b[i,1]>=0 then
    begin
    for j := 2 downto 1 do
	begin
	if j = 2 then cc := TX_C else cc := RX_C;
	if b[i,j] = last[j] then 
	    begin
	    vdraw(i, maxy-1 - b[i,j], cc);
	    draw_bar(i, maxy - b[i,j], cc);
	    end
	    else begin
		f := 0;
		y := last[j];
		if b[i,j] > last[j] then yi := 1 else yi := -1;
		fi := 1 / (abs(last[j]-b[i,j]));
		for k := 0 to abs(last[j]-b[i,j]) do
		    begin
		    if i > 0 then 
			fdraw(i-1, maxy - 1 - y, cc, (1-f));
		    fdraw(i,  maxy - 1 - y, cc, f);
		    inc(y, yi);
		    f := f + fi;
		    end;
		draw_bar(i, maxy - b[i,j], cc);
		end;
	last[j] := b[i,j];
	end;
    end else begin  last[1] := 0; last[2] := 0; end;
{$IFDEF FRAME}
 draw_frame;
{$ENDIF}    
 Write_BMP;
 end;


BEGIN
opt := -1;
if InX then
    begin
    if (paramcount <> 1) then opt := 1;
    if paramcount = 1 then
	begin
	if paramstr(1) = '1' then opt := 1;
	if paramstr(1) = '2' then opt := 2;
	end;
    case opt of
	1 : begin interval := 1 ;{ outfile := outfile1;} DoWork; end;
	2 : begin interval := 15;{ outfile := outfile2;} DoWork; end;
	else WriteLn('Incorrect parameter(could be "1" or "2").');
	end;
    end;
END.
