Uses oldLinuX;

{this could turn on the smoother line filter}
{$DEFINE BILINEA}
{$DEFINE OUTPUT_STDOUT}
{$DEFINE FRAME}


Const MAXX = 1440; { X size of the image, in pixels}
      MaxY = 200; { Y size of the image, in pixels}
      
      MinTemp = 20;
      MaxTemp = 85;
      SCALE   = 3;
      
{$IFDEF FRAME}
      fr_MAXX = MAXX + 20;
      fr_MAXY = MAXY + 20;
{$ELSE}
      fr_MAXX = MAXX;
      fr_MAXY = MAXY;
{$ENDIF}      
      MAXE = 20000; 
    {max speeds, in bits per second}
      SOLID_Y = 36;
      PERIOD = 10;
      LLENGTH = 4;
      
      FUTURE   = -1;
      NO_POWER = -2;
      
      InFile = '/home/vesko/develop/vgpanel/tempst.log';
{      OutFile1 = '/home/vesko/develop/vgpanel/minutely.jpg';
      OutFile2 = '/home/vesko/develop/vgpanel/quartrly.jpg';}
      
{KOLORS Section: each color is an ARGB in a longint, with blue in the LSB}      

      NO_POWER_C = 	$7fffc08f;
      FUTURE_C   =	$3fffffff;
      CPU_C =		$06ff1414;
      SYS_C =		$06046404;
      THM_C =		$0676887d;
      BACKGROUND =	$00ffffff;
      GRID	 =	$00dddddd;
      HTML =		$00538fcc;
      
Type   Long3  = array [1..3] of longint;
       Report = Record
		time : Longint;
		temp : Long3;
		End;
		
{.BMP Phile Format:}		

const  BM_MAGIC  = 19778;

type	BM_HEADER = record
		    fs : Longint;
		    lzero : Longint;
		    bfImgOffset : Longint;
		    end;
	BM_iHEADER= record
		    ihdrSize : Longint;
		    x, y : Longint;
		    channels, bpp : Integer;
		    comp, biSizeImage : Longint;
		    PixPerM_X, PixPerM_Y : Longint;
		    colors, colorsimportant : Longint;
		    end;

      arr = array [0..MAXE-1] of Report;
      scarr = array [0..mAXX-1, 0..MAXY -1] of longint;
      sc_fr_arr = array [0..FR_MAXX-1, 0..FR_MAXY-1] of longint;

var 
    n : Longint;
    a : arr;
    P : scarr;
{$IFDEF FRAME}    
    Q : sc_fr_arr;
{$ELSE}
    Q : scarr;    
{$ENDIF}
    interval, iv : longint;
{    outfile : String;}

Function FileExists(fn : string) : boolean;
 var g : Stat;
 begin
    fstat (fn, g);
    fileexists := (LINUXeRROR <> SYS_ENOENT);
 end;
 
Procedure Write_BMP;
 var G : BM_HEADER;
     H : BM_iHEADER;
     i, j, k : Integer;
     f : File Of Byte;
     row : Array [0..3 + Fr_MAXX * 3] of byte;
     rowsz : Longint;
 begin
{$IFNDEF FRAME}
 q := p;
{$ENDIF} 
 
 fillchar(g, sizeof(g), 0);
 fillchar(h, sizeof(h), 0);
{$IFDEF OUTPUT_STDOUT}
 assign(f, '');
{$ELSE}
 assign(f, 'test.bmp');
{$ENDIF}
 rewrite(f);
 
 rowsz := Fr_MAXX * 3;
 if rowsz mod 4 <> 0 then
    inc(rowsz, 4 - (rowsz mod 4));
 g.fs := 54 + rowsz * Fr_MAXY;
 g.bfImgOffset := 54;
 h.iHdrSize := 40;
 h.x := Fr_MAXX; h.y := Fr_MAXY;
 h.channels := 1;
 h.bpp := 24;
 k := BM_MAGIC;
 blockwrite(f, k, 2);
 blockwrite(f, g, sizeof(g));
 blockwrite(f, h, sizeof(h));
 fillchar(row, sizeof(row), 0);
 for j := Fr_MAXY - 1 downto 0 do
    begin
    for i := 0 to Fr_MAXX - 1 do	
	for k := 0 to 2 do 
	    begin
	    row [i*3+k] := 255 and q[i,j];
	    q[i,j] := q[i,j] shr 8;
	    end;
    blockwrite(f, row, rowsz);
    end;
 close(f);
 end; 

Function InX : boolean;
 var t : text;
 
 Function Safe_readLn(var a, b, c, e : Longint) : boolean;
  var s : string;
      i : integer;
      d : integer;
  begin
  safe_readln := false;
  readln(t, s);
  for i := 1 to length(s) do if not (s[i] in [' ','0'..'9']) then exit;

  i := pos(' ', s);
  if i = 0 then exit;
  val(copy(s, 1, i-1), a, d);
  if d <> 0 then exit;
  delete(s, 1, i);

  i := pos(' ', s);
  if i = 0 then exit;
  val(copy(s, 1, i-1), b, d);
  if d <> 0 then exit;
  delete(s, 1, i);

  i := pos(' ', s);
  if i = 0 then exit;
  val(copy(s, 1, i-1), c, d);
  if d <> 0 then exit;
  delete(s, 1, i);

  val(s, e, d);
  if d <> 0 then exit;
  safe_readln := true;
  end;
 
 begin
 InX := FALSE;
 if not fileexists(infile) then
    begin
    writeLn('The file does not exist: "',infile,'".');
    exit;
    end;
 assign(t, infile);
 reset(t);
 n := 0;
 while not seekeof(t) do
    begin
    if safe_readln( a[n].time, a[n].temp[1], a[n].temp[2], a[n].temp[3] ) then inc(n);
    end;
 close(t);
 InX := TRUE;
 end;
 
Function clamp(a : longint) : longint;
 begin
 if a > 255 then a := 255;
 if a < 0 then a := 0;
 clamp := a;
 end; 
 
Procedure Decompose(col : longint; var alpha, r, g, b : longint);
 begin
 b := col and $ff; 	col := col shr 8;
 g := col and $ff;	col := col shr 8;
 r := col and $ff;	col := col shr 8;
 alpha := col;
 end;  
 
Procedure VDraw(x, y : integer; col : longint);
 begin
 if (x>=0) and (x<MAXX) and (y>=0) and (y<MAXY) then
    p[x,y] := col;
 end;  
 
Function MultiPlyColor(col : Longint; amp : real) : longint;
 var r,g, b, a : longint;
 begin
 Decompose(col, a, r, g, b);
 r := clamp(trunc(r*amp));
 g := clamp(trunc(g*amp));
 b := clamp(trunc(b*amp));
 MultiplyColor := r shl 16 + g shl 8 + b;
 end; 
 
Procedure Fdraw(x, y : integer; col : longint; transp : real);
 begin
 if transp > 1 then transp := 1;
 if transp < 0 then transp := 0;
 if (x>=0) and (x<MAXX) and (y>=0) and (y<MAXY) then
    p[x,y] := {safeadd(}multiplycolor(p[x,y], (1-transp)) +{,} multiplycolor(col, transp){)}; 
 end; 

Procedure Frdraw(x, y : integer; col : longint; transp : real);
 begin
 if transp > 1 then transp := 1;
 if transp < 0 then transp := 0;
 if (x>=0) and (x<fr_MAXX) and (y>=0) and (y<fr_MAXY) then
    q[x,y] := multiplycolor(q[x,y], (1-transp)) + multiplycolor(col, transp); 
 end; 

Procedure Draw_solid(y : Integer); 
 var i : integer;
 begin
 for i := 0 to maxx - 1 do
    p[i,y] := GRID;
 end;
 
Procedure Draw_dotted(y : integer);
 var i : integer;
 begin
 for i := 0 to maxx - 1 do
    if (i mod PERIOD < LLENGTH) then 
	p[i,y] := GRID;
 end; 

Procedure Draw_Secondary_lines;
 var i : longint;
 begin
 for i := mintemp to maxtemp do 
    begin
    if i mod 5 = 0 then
	begin
	draw_dotted(maxy-1-(i-mintemp)*SCALE);
	if i mod 10 = 0 then draw_solid(maxy-1-(i-mintemp)*SCALE);
	end;
    end;
 end;

Procedure PrepareImage;
 var i, j : Integer;
     interleave : Integer;
 begin
{ fillchar(p, sizeof(p), 0);}
 interleave := 60;
 for j := 0 to MaxY - 1 do
    for i := 0 to MaxX - 1 do p[i,j] := BACKGROUND;
 for j := 0 to Maxy-1 do
    for i := 0 to Maxx - 1 do 
	if i mod interleave = 0 then p[i,j] := GRID;
 end;
 
Procedure Draw_bar(x, start_y : Integer; col : Longint);
 var f : real;
     i : integer;
 begin
 f := (col shr 24) / 255.0;
 for i := start_y to MaxY - 1 do
    fdraw(x, i, col, f);
 end; 
 
Function GetF(x, max : Integer): real;
 begin
 if x< 20 then getf := (10-x)/10
	  else if x >= max-20 then getf := (10-(max-1-x))/10 else
	    getf := -10;
 end; 
 
Function Clipf(f : real) : real;
 begin
 if f < 0 then clipf := 0 else clipf := f;
 end; 
 
Function clip1(f : real) : real;
 begin
 if f > 1 then clip1 := 1.0
	  else clip1 := f;
 end; 
 
Function Kombine(f1, f2 : real) : real;
 var g : integer;
 begin
 g := integer(f1 > -5);
 g := g * 2 + integer(f2 > -5);
 case g of
    0: kombine := 0;
    1: kombine := clipf(f2);
    2: kombine := clipf(f1);
    3: kombine := clip1(0.80 * sqrt(sqr(clipf(f1+0.2)) + sqr(clipf(f2+0.2))));
    end;
 end; 
 
Procedure Draw_frame;
 var i, j : integer;
     f1, f2 : real;
 begin
 {fill:}
 for i := 0 to fr_MAXX - 1 do
    for j := 0 to fr_MaxY - 1 do q[i,j] := BACKGROUND;
 {kopy:}
 for i := 0 to MAXX - 1 do
    for j := 0 to maxy - 1 do
	q[i+10, j+10] := p[i,j];
 {enframe:}
 for i := 0 to FR_MAXX  - 1 do
    for j := 0 to FR_MAXY - 1 do
	begin
	f1 := GetF(i, FR_MAXX);
	f2 := GetF(j, FR_MAXY);
	frdraw(i,j, HTML, Kombine(f1, f2));
	end;
 end; 
 
Function GetState(time : LonGInT) : LOngint;
 var l, r, m, tgi : Longint;
 begin
 if (time < a[0].time - iv) then 
    begin
    GetState := NO_POWER; {out of recorded universum}
    exit;
    end;
{ if time < a[0].time then
    begin
    GetState := 0;
    if a[0].rx = -1 then GetState := NO_NET;
    exit;
    end;}
 if time > a[n-1].time+iv then
    begin
    GetState := FUTURE;
    exit;
    end;
 l := 0;
 r := n - 1;
 while (r-l > 1) do
    begin
    m := (l+r) div 2;
    if a[m].time > time then 
	r := m
	else
	l := m;
    end;
 if abs(time - a[l].time) < abs(time - a[r].time) then
	tgi := l
    else
	tgi := r;
 if abs(time - a[tgi].time ) > iv then
    begin
    GetState := NO_POWER;
    exit;
    end;
 GetState := TGI;
 end; 
 
Procedure DoWork(x, input_color : Longint);
 var ct, t, r : Longint;
     i : Integer;
     last : integer;
     drx : longint;
     b : array [0..MAXX-1] of Longint;
     xmax : longint;
     cc : longint;
     y, yi, k : integer;
     f, fi : real;
     midnight : longint;
 begin
 if x = 3 then PrepareImage;
 ct := GetEpochTime;
 iv := Interval * 60;
 midnight := ct - ct mod (3600*24);
 for i := 0 to maxx - 1 do
    begin
    t := midnight + iv * i;
    r := getState(t);
    if r < 0 then
	begin
	if x = 3 then
	case r of
	    FUTURE: draw_bar(i, MAXY - SOLID_Y, FUTURE_c);
	    NO_POWER : draw_bar(i, MAXY - SOLID_Y,  NO_POWER_C);
	    end;
	drx := -1;
	end
	else
	begin
        drx := a[r].temp[x] - MinTemp;
	if drx<0 then drx := 0;
	if drx > maxtemp-mintemp then drx := maxtemp-mintemp;
	end;
	
    b[i] := drx;
    end;
 xmax := maxtemp-mintemp;
 if x = 3 then draw_secondary_lines;
 for i := 0 to maxx - 1 do
    if b[i] >= 0 then 
	b[i] := b[i]*scale;
 last := b[0];
 for i := 0 to maxx - 1 do if b[i]>=0 then
    begin
	cc := input_color;
	if b[i] = last then 
	    begin
	    vdraw(i, maxy-1 - b[i], cc);
	    draw_bar(i, maxy - b[i], cc);
	    end
	    else begin
		f := 0;
		y := last;
		if b[i] > last then yi := 1 else yi := -1;
		fi := 1 / (abs(last-b[i]));
		for k := 0 to abs(last-b[i]) do
		    begin
		    if i > 0 then 
			fdraw(i-1, maxy - 1 - y, cc, (1-f));
		    fdraw(i,  maxy - 1 - y, cc, f);
		    inc(y, yi);
		    f := f + fi;
		    end;
		draw_bar(i, maxy - b[i], cc);
		end;
	last := b[i];
    end else last := 0;
{$IFDEF FRAME}
 if x = 1 then draw_frame;
{$ENDIF}    
 if x = 1 then Write_BMP;
 end;

BEGIN
if InX then
    begin
    Interval := 1;
    DoWork(3, THM_C);
    DoWork(2, SYS_C);
    DoWork(1, CPU_C);
    end;
END.
