Uses oldLinux;

type
	PDataStr = ^TDataStr;
	PChain	 = ^TChain;
	TDataStr = record
		   s : String;
		   next : PDataStr;
		   end;
	TChain	 = record
		   name : String;
		   count : Integer;
		   data : PDataStr;
		   next  : PChain;
		   end;
	Long3    = Array [1..3] Of Longint;


const SetiPath = '/home/vesko/SETI/';
{      OutFIle  = '/usr/share/collect';}
      OutFile  = '/tmp/collect.txt';
      datadir  = '/home/vesko/develop/vgpanel/data/';
      htmldir  = '/var/www/htdocs/vgpanel/';
      thermal_cmd  = '/usr/local/bin/sensors';
      thermal_tmp  = '/tmp/vgmain_sen';


{ ==========================   variables  =================================== }


var SetiUnits : Longint;


    NetTran  : String;
    UpTime   : String;
    SetiRunning : String;
    
    SetiProg    : Real;
    UpIdle      : Real;
    UpTotal     : Real;
    
    temperatures : long3; { we get it from lmsensors enabled kernels }
    CPURPM	 : Longint;
    
Procedure Cry(error : String);
 begin
 WriteLn(error);
 halt(1);
 end;    

Function FileExists(fn : String ) : boolean; 
 var G : Stat;
 begin
 FStat(fn, g);
 FileExists := (LinuxError <> SYS_ENoEnt);
 end;


Function Grep(fn : String; pattern : String) : string;
 var t : text;
     s : string;
 begin
 assign(t, fn);
 reset(t);
 while not eof(t) do
    begin
    readln(t, s);
    if pos(pattern, s ) <> 0 then
	begin
	grep := s;
	exit;
	end;
    end;
 close(t);
 s := '';
 end;
 
Function GetNumberOf( S : String ) : longint;
 var z : longint;
     i : integer;
 begin
 z := 0;
 i := 1;
 while i <= length(s) do 
    begin
    if s[i] in ['0'..'9'] then
	begin
	while (s[i] in ['0'..'9']) and (i<=length(s)) do
	    begin
	    z := z * 10 + ord(s[i])-ord('0');
	    inc(i);
	    end;
	GetNumberOf := z;
	exit;
	end;
    inc(i);
    end;
 GetNumberOf := -1;
 end; 

Function ProcessExists (pName : String) : Boolean;
 begin
 Shell('ps -A > /tmp/vgptmp');
 ProcessExists := (Grep('/tmp/vgptmp', pName) <> '');
 end;
 
 
Procedure LtoA2(v : Longint; var s : String);
 begin
 s := chr(v div 10 + 48) + chr(v mod 10 + 48);
 if v > 99 then
    begin
    v := v div 100;
    while v > 0 do
	begin
	s := chr(v mod 10 + 48);
	v := v div 10;
	end;
    end;
 end;


{************************** INPUT PART ***************************************}

Procedure ScanSETI;
    var d : Integer;
	s : string;
    begin
    if processExists('setiathome') and FileExists (setipath + 'state.sah') 
				   and FileExists (setipath + 'user_info.sah') then
	begin
	SetiRunning := 'RUNNING';
	s := grep(SetiPATH + 'state.sah', 'prog');
	val(copy(s, pos('=', s) + 1, 255), SetiProg, d);
	SetiProg := SetiProg * 100.0;
	s := grep(SetiPATH + 'user_info.sah', 'nresults');
	val(copy(s, pos('=', s) + 1, 255), SetiUnits, d);
	end
	else
	begin
	SetiRunning := 'STOPPED';
	SetiProg := 0;
	SetiUnits := 0;
	end;
    end;
    
Procedure ScanNet;
    begin
    shell('ifconfig ppp0 > /tmp/vgntmp');
    NetTran := grep('/tmp/vgntmp', 'RX bytes');
    end;
    
Procedure ScanUptimes;
    var t : text;
	UpScds : Longint;
	s1, s : String;
    begin
    assign(t, '/proc/uptime');
    reset(t);
    ReadLn(t, UpTotal, UpIdle);
    close(t);
    UpScds := round(UpTotal);
    ltoa2(UpScds mod 60, s);
    UpScds := Upscds div 60;
    ltoa2(UpScds mod 60, s1);
    s := s1+'m '+s+'s.';
    UpScds := Upscds div 60;
    if UpScds > 0 then
	begin
	ltoa2(UpScds mod 24, s1);
	s := s1 + 'h '+s;
	upscds := upscds div 24;
	if upscds > 0 then
	    begin
	    ltoa2(Upscds, s1);
	    s := s1 +'d '+s;
	    end;
	end;
    UpTime := s;
    end;
    
Procedure GetTemps;
    var s : string;
    begin
	shell(thermal_cmd + ' > ' + thermal_tmp);
	s := Grep(thermal_tmp, 'CPU Temp:');
	if s = '' then temperatures[1] := -1
	          else temperatures[1] := GetNumberOf(s);

	s := Grep(thermal_tmp, 'M/B Temp:');
	if s = '' then temperatures[2] := -1
	          else temperatures[2] := GetNumberOf(s);

	s := Grep(thermal_tmp, 'temp3:');
	if s = '' then temperatures[3] := -1
	          else 
		    begin
		    delete(s, 1, pos(':', s));
		    temperatures[3] := GetNumberOf(s);
		    end;

	s := Grep(thermal_tmp, 'CPU Fan');
	if s = '' then CPURPM := -1
	          else CPURPM := GetNumberOf(s);
    end;    

Procedure ScanInfo;
    begin
    ScanSeti;
    ScanNet;
    ScanUptimes;
    GetTemps;
    end;
    
{
 ******************************************************************************
 ********** END OF INPUT PART *************************************************
 ******************************************************************************
 }

{
 ******************************************************************************
 **********  START OF OUTPUT PART *********************************************
 ******************************************************************************
 }    
    
Procedure OutX;
    var t : Text;
    begin
    assign(t, outfile);
    rewrite(t);
    {------------------------------}
    WriteLn(t, 'SETIRUNNING,1');
    WriteLn(t, setirunning);
    WriteLn(t, 'SETIPROG,1');
    WriteLn(t, SetiProg:1:3);
    WriteLn(t, 'SETIUNITS,1');
    WriteLn(t, SetiUnits);
    {------------------------------}
    WriteLn(t, 'NETTRAN,1');
    WriteLn(t, NetTran);
    {------------------------------}
    WriteLn(t, 'UPTIME,1');
    WriteLn(t, UpTime);
    WriteLn(t, 'UPTIMETOTAL,1');
    WriteLn(t, UpTotal:1:3);
    WriteLn(t, 'UPTIMEIDLE,1');
    WriteLn(t, UpIdle :1:3);
    WriteLn(t, 'TEMPERATURE1,1');
    WriteLn(t, temperatures[1]);
    WriteLn(t, 'TEMPERATURE2,1');
    WriteLn(t, temperatures[2]);
    WriteLn(t, 'TEMPERATURE3,1');
    WriteLn(t, temperatures[3]);
    WriteLn(t, 'CPURPM,1');
    WriteLn(t, CPURPM);
    close(t);
    end;    

{
 ******************************************************************************
 ********** END OF OUTPUT PART ************************************************
 ******************************************************************************
 }    

{
 ******************************************************************************
 *********** START OF HTML GENERATOR PART *************************************
 ******************************************************************************
 }
 
Function  Parse_Collect(CollectFile : String) : PChain;
    var p, Q : PChain;
	Z, Y    : pDataStr;
	t 	: text;
	s 	: string;
	i,d 	: integer;
    begin
    assign(t, CollectFile);
    reset(t);
    P := NIL;
    while not seekeof(t) do	
	begin
	readln(t, s);
	new(q);
	q^.name := copy(s, 1, pos(',', s) -1 );
	delete(s, 1, pos(',', s));
	val(s, i, d);
	q^.count := i;
	q^.next := p;
	p := q;
	q^.data := NIL;
	for i := 1 to q^.count do
	    begin
	    readln(t, s);
	    new(z);
	    z^.s := s;
	    z^.next := NIL;
	    if q^.data = NIL then 
		begin
		q^.data := z;
		y := z;
		end
		else
		begin
		y^.next := z;
		y := z;
		end;
	    end;
	end;
    close(t);
    Parse_Collect := p;
    end; 
    
Procedure Parse_Destroy(p : PChain);
 var q : PChain;
     z, y : PDataStr;
 begin
 q := p;
 while p <> NIL do	
    begin
    q := p;
    p := q^.next;
    y := q^.data;
    dispose(q);
    while y <> NIL do
	begin
	z := y;
	y := y^.next;
	dispose (z);
	end;
    end;
 end;
 
Function Lookup_Chain(p : PChain; keyword : String) : PDataStr;
    begin
	while p <> NIL do	
	    begin
	    if p^.name = keyword then
		begin
		LookUp_CHain := p^.data;
		exit;
		end;
	    p := p^.next;
	    end;
	LookUp_CHain := NIL;
    end; 
 
Function GetSVal(p : PChain; keyword  : String) : string;
 var q : PDataStr;
 begin
 q := Lookup_Chain(p, keyword);
 if q = nil then getsval := '' else GetSVal  := q^.s;
 end;
 
Procedure Plain_Insert(fn : String; ifn : String) ; 
    var fi, fo : text;
	parse : PChain;
	i, j : Integer;
	s : String;
    begin
    parse := Parse_Collect(ifn);
    assign(fi, datadir + fn);
    reset(fi);
    assign(fo, htmldir + fn);
    rewrite(fo);
    
    while not eof(fi) do
	begin
	readln(fi , s);
	if pos('###', s) = 0 then
	    writeln(fo, s)
	    else
	    begin
	    i := pos('###', s);
	    j := -1;
	    while (s[i]<>')') and (i < length(s)) do 
		begin
		if s[i] = '(' then j := i;
		inc(i);
		end;
	    if (s[i]<>')') or (j=-1) then
		cry('fatal error : collect mismatch!');
{	    writeLN('[');
	    writeln(copy(s, 1, pos('###', s) - 1));
	    writeln(GetSVal(parse, copy(s, j+1, i-j-1)));
	    WriteLn(copy(s, i+1, 255));
	    writeln(']');}
	    s := copy(s, 1, pos('###', s) - 1) + GetSVal(parse, copy(s, j+1, i-j-1)) + copy(s, i+1, 255);
	    writeln(fo,s );
	    end;
	end;
    
    close(fo);
    close(fi);
    Parse_Destroy(parse);
    end; 
 
Procedure Gen_HTML;
    begin
    Plain_Insert('index.htm', '/tmp/collect.txt');    
    end; 
 
BEGIN
ScanInfo;
OutX;
Gen_HTML;
END.
